package com.persagy.fm.common.model.entity;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Data;

import java.util.Date;

/**
 * 审计信息父类
 * @author Charlie Yu
 * @version 1.0 2021-03-04
 */
@Data
public abstract class AuditableEntity<T> extends BaseEntity<T> implements IAuditableEntity {

    /** 序列id */
    private static final long serialVersionUID = -6039076670318997447L;

    /** 创建时间 */
    public static final String PROP_CREATIONTIME = "creation_time";
    public static final String DO_PROP_CREATIONTIME = "creationTime";

    /** 创建人 */
    public static final String PROP_CREATOR = "creator";

    /** 最后一次修改时间 */
    public static final String PROP_MODIFIEDTIME = "modified_time";
    public static final String DO_PROP_MODIFIEDTIME = "modifiedTime";

    /** 最后一个修改人 */
    public static final String PROP_MODIFIER = "modifier";

    /**
     * 创建时间
     */
    @JsonIgnore
    @TableField(fill = FieldFill.INSERT)
    protected Date creationTime;

    /**
     * 创建人
     */
    protected String creator;

    /**
     * 最后一次修改时间
     */
    @JsonIgnore
    @TableField(fill = FieldFill.INSERT_UPDATE)
    protected Date modifiedTime;

    /**
     * 最后一次修改人
     */
    protected String modifier;

}
